| ## Public API Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- File List
- File Members

# csutil/array.h File Reference

Generic Array Template. More...

`#include "csutil/allocator.h"`
`#include "csutil/comparator.h"`
`#include "csutil/custom_new_disable.h"`
`#include "csutil/custom_new_enable.h"`

Go to the source code of this file.

## Classes
class | csArray< T, ElementHandler, MemoryAllocator, CapacityHandler >
| A templated array class. More...
class | csArray< T, ElementHandler, MemoryAllocator, CapacityHandler >::ConstIterator
| Iterator for the Array<> class. More...
class | csArray< T, ElementHandler, MemoryAllocator, CapacityHandler >::Iterator
| Iterator for the Array<> class. More...
struct | csArrayCapacityDefault
class | csArrayCapacityLinear< Threshold >
| csArray capacity handler. More...
class | csArrayCmp< T, K >
| A functor template which encapsulates a key and a comparison function for use with key-related csArray<> searching methods, such as FindKey() and FindSortedKey(). More...
class | csArrayElementHandler< T >
| The default element handler for csArray. More...
class | csArraySafeCopyElementHandler< T >
| Special element handler for csArray that makes sure that when the array is reallocated that the objects are properly constructed and destructed at their new position. More...
class | csArrayThresholdFixed< N >
| csArray fixed threshold for capacity handlers. More...
class | csArrayThresholdVariable
| csArray variable threshold for capacity handlers. More...
class | csSafeCopyArray< T >
| Convenience class to make a version of csArray<> that does a safe-copy in case of reallocation of the array. More...
## Variables
const size_t | csArrayItemNotFound = (size_t)-1
| This value is returned whenever an array item could not be located or does not exist.

## Detailed Description

Generic Array Template.

Definition in file array.h.